---
title: Using the CSS Painting API
slug: Web/API/CSS_Painting_API/Guide
tags:
  - CSS
  - CSS Paint API
  - Canvas
  - Houdini
  - Learn
---
<p>The CSS Paint API is designed to enable developers to programmatically define images which can then be used anywhere a CSS image can be invoked, such as CSS <code><a href="/en-US/docs/Web/CSS/background-image">background-image</a></code>, <code><a href="/en-US/docs/Web/CSS/border-image-source">border-image</a></code>, <code><a href="/en-US/docs/Web/CSS/mask-image">mask-image</a></code>, etc.</p>

<p>To programmatically create an image used by a CSS stylesheet we need to work through a few steps:</p>

<ol>
 <li>Define a paint worklet using the <code><a href="/en-US/docs/Web/API/PaintWorklet/registerPaint">registerPaint()</a></code> function</li>
 <li>Register the worklet</li>
 <li>Include the <code>{{cssxref('paint()','paint()')}}</code> CSS function</li>
</ol>

<p>To elaborate over these steps, we're going to start by creating a half-highlight background, like on this header:</p>

<p><img alt="Text reading 'My Cool Header' with a solid yellow background image block on the bottom left two thirds of the header" src="https://mdn.mozillademos.org/files/16774/mycoolheader.png" style="height: 54px; width: 239px;"></p>

<h2 id="CSS_paint_worklet">CSS paint worklet</h2>

<p>In an external script file, we employ the <code><a href="/en-US/docs/Web/API/PaintWorklet/registerPaint">registerPaint()</a></code> function to name our <a href="/en-US/docs/Web/API/PaintWorklet">CSS Paint worklet</a>. It takes two parameters. The first is the name we give the worklet — this is the name we will use in our CSS as the parameter of the <code>paint()</code> function when we want to apply this styling to an element. The second parameter is the class that does all the magic, defining the context options and what to paint to the two-dimensional canvas that will be our image.</p>

<pre class="brush: js">registerPaint('headerHighlight', class {

  /*
       define if alphatransparency  is allowed alpha
       is set to true by default. If set to false, all
       colours used on the canvas will be fully opaque
    */
  static get contextOptions() {
           return { alpha: true };
    }

    /*
        <strong>ctx</strong> is the 2D drawing context
        a subset of the <a href="/en-US/docs/Web/API/Canvas_API">HTML5 Canvas API</a>.
    */
  paint(ctx) {
        ctx.fillStyle = 'hsla(55, 90%, 60%, 1.0)';
        ctx.fillRect(0, 15, 200, 20);     /* order: x, y, w, h */
  }
});</pre>

<p>In this class example we have defined a single context option with the <code>contextOptions()</code> function: we returned a simple object stating alpha transparency is allowed.</p>

<p>We have then used the <code>paint()</code> function to paint to our canvas.</p>

<p>A <code>paint()</code> function can take three arguments. Here we have provided one argument: the rendering context (we'll look at more in due course), often refered to by the variable name <code>ctx</code>. The 2D Rendering Context is a subset of the <a href="/en-US/docs/Web/API/Canvas_API">HTML5 Canvas API</a>; the version available to Houdini (called the <code>PaintRenderingContext2D</code>) is a further subset containing most of the features available in the full Canvas API with the <a href="https://drafts.css-houdini.org/css-paint-api-1/#2d-rendering-context)">exception</a> of the <code>CanvasImageData</code>, <code>CanvasUserInterface</code>, <code>CanvasText</code>, and <code>CanvasTextDrawingStyles</code> APIs.</p>

<p>We define the <code><a href="/en-US/docs/Web/API/CanvasRenderingContext2D/fillStyle">fillStyle</a></code> as being <code>hsla(55, 90%, 60%, 1.0)</code>, which is a shade of yellow, and then call <code>fillRect()</code> to create a rectangle of that color. The <code><a href="/en-US/docs/Web/API/CanvasRenderingContext2D/fillRect">fillRect()</a></code> parameters are, in order, x-axis origin, y-axis origin, width, and height. <code>fillRect(0, 15, 200, 20)</code> results in the creation of a rectangle that is 200 units wide by 20 units tall, positioned 0 units from the left and 15 units from the top of the content box.</p>

<p>We can use the CSS <code><a href="/en-US/docs/Web/CSS/background-size">background-size</a></code> and <code><a href="/en-US/docs/Web/CSS/background-position">background-position</a></code> properties to re-size or relocate this background image, but this is the default size and placement of the yellow box we created in our paint worklet.</p>

<p>We tried to keep the example simple. For more options, look at the <a href="/en-US/docs/Web/HTML/Element/canvas">canvas documentation</a>. We also add a little bit of complexity later in this tutorial.</p>

<h2 id="Using_the_paint_worklet">Using the paint worklet</h2>

<p>To use the paint worklet, we need to register it using <code><a href="/en-US/docs/Web/API/Worklet/addModule">addModule()</a></code> and include it in our CSS, ensuring the CSS selector matches a DOM node in our HTML</p>

<h3 id="Registering_the_worklet">Registering the worklet</h3>

<p>The setup and design of our paint worklet took place in the external script shown above. We need to register that <a href="/en-US/docs/Web/API/PaintWorklet">worklet</a> from our main script.</p>

<pre class="brush: js">CSS.paintWorklet.addModule('nameOfPaintWorkletFile.js');</pre>

<p>This can be done using the paint worklet's <code>addModule()</code> method in a <code>&lt;script&gt;</code> within the main HTML or in an external JavaScript file linked to from the document.</p>

<p>In our example, the paintworklet is stored on Github.</p>

<div id="paintapi">
<pre class="brush: js">CSS.paintWorklet.addModule('https://mdn.github.io/houdini-examples/cssPaint/intro/01partOne/header-highlight.js');</pre>

<h3 id="Reference_the_paint_worklet_in_CSS">Reference the paint worklet in CSS</h3>

<p>Once we have a registered paint worklet, we can use it in CSS. Employ the CSS <code>paint()</code> function like we would any other <code>&lt;image&gt;</code> type, using the same string identifier we used in the paintworklet's <code>registerPaint()</code> function.</p>

<pre class="brush: css">.fancy {
  background-image: paint(headerHighlight);
}</pre>

<h3 id="Putting_it_together">Putting it together</h3>

<p>We can then add the fancy class to any element on the page to add a yellow box as a background:</p>

<pre class="brush: html">&lt;h1 class="fancy"&gt;My Cool Header&lt;/h1&gt;</pre>

<p>The following example will look like the image above in <a href="/Web/API/CSS/paintWorklet#Browser_compatibility">browsers supporting the CSS Painting API</a>.</p>
</div>

<p>{{EmbedLiveSample("paintapi", 120, 120)}}</p>

<p>While you can't play with the worklet's script, you can alter the <code>background-size</code> and <code>background-position</code> to change the size and location of the background image.</p>

<h2 id="PaintSize">PaintSize</h2>

<p>In the example above, we created a 20x200 unit box, painted 15 units from the top of the element  it is the same regardless of the size of the element. If the text is small, the yellow box looks like a huge underline. If the text is huge, the box might look like an bar above the first three letters. It would be better if the background image was relative to the size of the element — we can use the element's <code>paintSize</code> property to ensure the background image is proportional to the size of the element's box model size.</p>

<p><img alt="The background is 50% of the height and 60% of the width of the element" src="https://mdn.mozillademos.org/files/16783/mycoolheadersized.png" style="height: 148px; width: 554px;"></p>

<p>In the above image, the background proportional to the size of the element. The 3rd example has <code>width: 50%</code>; set on the block level element, making the element narrower and therefore the background image narrower.</p>

<p>The code to do this looks like so:</p>

<pre class="brush: js">registerPaint('headerHighlight', class {

  static get contextOptions() {
           return { alpha: true };
  }

    /*
        <strong>ctx</strong> is the 2D drawing context
        <strong>size</strong> is the paintSize, the dimensions (height and width) of the box being painted
    */

  paint(ctx, size) {
        ctx.fillStyle = 'hsla(55, 90%, 60%, 1.0)';
        ctx.fillRect( 0, size.height / 3, size.width * 0.4, size.height * 0.6 );
  }
});</pre>

<p>This code example has two differences from our first example:</p>

<ol>
 <li>We've included a second argument, which is the paint size.</li>
 <li>We've changed the dimensions and positioning of our rectangle to be relative to the size of the element box rather than absolute values.</li>
</ol>

<p>We can pass the second parameter into the <code>paint()</code> function to give us access to the width and the height of the element, via <code>.width</code> and <code>.height</code> properties.</p>

<p>Our header now has a highlight that changes according to it's size.</p>

<div class="hidden" id="example2">
<pre class="brush: js">CSS.paintWorklet.addModule('https://mdn.github.io/houdini-examples/cssPaint/intro/02partTwo/header-highlight.js');</pre>

<pre class="brush: css">.fancy {
  background-image: paint(headerHighlight);
}
.half {
    width: 50%;
}</pre>

<pre class="brush: html">&lt;h1 class="fancy"&gt;Largest Header&lt;/h1&gt;
&lt;h6 class="fancy"&gt;Smallest Header&lt;/h6&gt;
&lt;h3 class="fancy half"&gt;50% width header&lt;/h3&gt;
</pre>
</div>

<p>While you can't play with the worklet's script, you can alter the element's <code>font-size</code> and <code>width</code> to change the size of the background image.</p>

<p>In browsers that support the CSS Paint API, the example below should appear like the image above.</p>

<p>{{EmbedLiveSample("example2", 300, 300)}}</p>

<h2 id="Custom_properties">Custom properties</h2>

<p>In addition to accessing the size of the element, the worklet can also have access to CSS custom properties and regular CSS properties.</p>

<pre class="brush: js">registerPaint('cssPaintFunctionName', class {
     static get inputProperties() { return ['PropertyName1', '--customPropertyName2']; }
     static get inputArguments() { return ['&lt;color&gt;']; }
     static get contextOptions() { return {alpha: true}; }

     paint(drawingContext, elementSize, styleMap) {
         // Paint code goes here.
     }
});
</pre>

<p>The three parameters of the <code>paint()</code> function include the drawing context, paint size and properties. To be able to access properties, we include the static <code>inputProperties()</code> method, which provides live access to CSS properties, including regular properties and <a href="/en-US/docs/Web/CSS/CSS_Variables">custom properties</a>, and returns an <code><a href="/en-US/docs/Glossary/array">array</a></code> of property names. We'll take a look at <code>inputArguments</code> in the last section.</p>

<h3 id="Example">Example</h3>

<div id="example3">
<p>Let's create a list of items with a background image that rotates between three different colors and three widths.</p>

<p><img alt="The width and color of the background image changes based on the custom properties" src="https://mdn.mozillademos.org/files/16784/boxbg.png" style="height: 255px; width: 739px;"></p>

<p>In our CSS, we provide a different color and a width subtractor for the background box we've created via the <code>--boxColor</code> and <code>--widthSubtractor</code> custom properties.</p>

<pre class="brush: html; hidden">&lt;ul&gt;
    &lt;li&gt;item 1&lt;/li&gt;
    &lt;li&gt;item 2&lt;/li&gt;
    &lt;li&gt;item 3&lt;/li&gt;
    &lt;li&gt;item 4&lt;/li&gt;
    &lt;li&gt;item 5&lt;/li&gt;
    &lt;li&gt;item 6&lt;/li&gt;
    &lt;li&gt;item 7&lt;/li&gt;
    &lt;li&gt;item 8&lt;/li&gt;
    &lt;li&gt;item 9&lt;/li&gt;
    &lt;li&gt;item 10&lt;/li&gt;
    &lt;li&gt;item 11&lt;/li&gt;
    &lt;li&gt;item 12&lt;/li&gt;
    &lt;li&gt;item 13&lt;/li&gt;
    &lt;li&gt;item 14&lt;/li&gt;
    &lt;li&gt;item 15&lt;/li&gt;
    &lt;li&gt;item 16&lt;/li&gt;
    &lt;li&gt;item 17&lt;/li&gt;
    &lt;li&gt;item&lt;/li&gt;
&lt;/ul&gt;
</pre>

<pre class="brush: js; hidden">CSS.paintWorklet.addModule('https://mdn.github.io/houdini-examples/cssPaint/intro/worklets/boxbg.js');</pre>

<pre class="brush: css">li {
   background-image: paint(boxbg);
   --boxColor: hsla(55, 90%, 60%, 1.0);
}

li:nth-of-type(3n) {
   --boxColor: hsla(155, 90%, 60%, 1.0);
   --widthSubtractor: 20;
}

li:nth-of-type(3n+1) {
   --boxColor: hsla(255, 90%, 60%, 1.0);
   --widthSubtractor: 40;
}</pre>
</div>

<p>In our worklet, we can reference those custom properties.</p>

<pre class="brush: js">registerPaint('boxbg', class {

  static get contextOptions() { return {alpha: true}; }

  /*
     use this function to retrieve any custom properties (or regular properties, such as 'height')
     defined for the element, return them in the specified array
  */
  <strong>static get inputProperties() { return ['--boxColor', '--widthSubtractor']; }</strong>

  paint(ctx, size, props) {
    /*
       ctx -&gt; drawing context
       size -&gt; paintSize: width and height
       props -&gt; properties: get() method
    */

    ctx.fillStyle = <strong>props.get('--boxColor')</strong>;
    ctx.fillRect(0, size.height/3, size.width*0.4 - <strong>props.get('--widthSubtractor')</strong>, size.height*0.6);
  }
});</pre>

<p>We used the <code>inputProperties()</code> method in the <code>registerPaint()</code> class to get the values of two custom properties set on an element that has <code>boxbg</code> applied to it and then used those within our <code>paint()</code> function. The <code>inputProperties()</code> method can return all properties affecting the element, not just custom properties.</p>

<p>In our <code>&lt;script&gt;</code> we register the worklet:</p>

<div id="paintapi">
<pre class="brush: js">CSS.paintWorklet.addModule('https://mdn.github.io/houdini-examples/cssPaint/intro/worklet/boxbg.js');</pre>
</div>

<p>{{EmbedLiveSample("example3", 300, 300)}}</p>

<p>While you can't play with the worklet's script, you can alter the custom property values to change the colors and width of the background image.</p>

<h2 id="Adding_complexity">Adding complexity</h2>

<p>The above examples might not seem very exciting, as you could recreate them in a few different ways with existing CSS properties, e.g. by positioning some decorative <a href="/en-US/docs/Learn/CSS/Howto/Generated_content">generated content</a> with <code><a href="/en-US/docs/Web/CSS/::before">::before</a>,</code> or including <code>background: linear-gradient(yellow, yellow) 0 15px / 200px 20px no-repeat;</code> What makes the CSS Painting API so interesting and powerful is that you can create complex images, passing variables, that automatically resize.</p>

<p>Let's take a look at a more complex paint example.</p>

<pre class="brush: js">registerPaint('headerHighlight', class {
  static get inputProperties() { return ['--highColour']; }
  static get contextOptions() { return {alpha: true}; }

  paint(ctx, size, props) {

		/* set where to start the highlight &amp; dimensions */
		const x = 0;
		const y = size.height * 0.3;
		const blockWidth = size.width * 0.33;
		const highlightHeight = size.height * 0.85;
        const color = props.get('--highColour');

		ctx.fillStyle = color;

		ctx.beginPath();
		ctx.moveTo( x, y );
		ctx.lineTo( blockWidth, y );
		ctx.lineTo( blockWidth + highlightHeight, highlightHeight );
		ctx.lineTo( x, highlightHeight );
		ctx.lineTo( x, y );
		ctx.closePath();
		ctx.fill();

		/* create the dashes */
		for (let i = 0; i &lt; 4; i++) {
			let start = i * 2;
			ctx.beginPath();
			ctx.moveTo( (blockWidth) + (start * 10) + 10, y );
			ctx.lineTo( (blockWidth) + (start * 10) + 20, y );
			ctx.lineTo( (blockWidth) + (start * 10) + 20 + (highlightHeight), highlightHeight );
			ctx.lineTo( (blockWidth) + (start * 10) + 10 + (highlightHeight), highlightHeight );
			ctx.lineTo( (blockWidth) + (start * 10) + 10, y );
			ctx.closePath();
			ctx.fill();
		}
  } // paint
});</pre>

<div id="example4">
<p>We can then create a little HTML that will accept this image as backgrounds:</p>

<pre class="brush: html">&lt;h1 class="fancy"&gt;Largest Header&lt;/h1&gt;
&lt;h3 class="fancy"&gt;Medium size header&lt;/h3&gt;
&lt;h6 class="fancy"&gt;Smallest Header&lt;/h6&gt;</pre>

<p>We give each header a different value for the <code>--highColour</code> <a href="/en-US/docs/Web/CSS/CSS_Variables">custom property</a></p>

<pre class="brush: css">.fancy {
  background-image: paint(headerHighlight);
}
h1 { --highColour: hsla(155, 90%, 60%, 0.7); }
h3 { --highColour: hsla(255, 90%, 60%, 0.5); }
h6 { --highColour: hsla(355, 90%, 60%, 0.3); }</pre>

<p>And we register our worklet</p>

<pre class="brush: js">CSS.paintWorklet.addModule('https://mdn.github.io/houdini-examples/cssPaint/intro/03partThree/header-highlight.js');</pre>

<p>{{EmbedLiveSample("example4", 300, 300)}}</p>

<p>While you can't edit the worklet itself, you can play around with the CSS and HTML. Maybe try <code><a href="/en-US/docs/Web/CSS/float">float</a></code> and <code><a href="/en-US/docs/Web/CSS/clear">clear</a></code> on the headers?</p>

<p>You could try making the background images above without the CSS paint API. It is doable, but you would have to declare a different, fairly complex linear gradient for each different color you wanted to create. With the CSS Paint API, one worklet can be re-used, with different colors passed in this case.</p>
</div>

<h2 id="Passing_parameters">Passing parameters</h2>

<p>With the CSS Paint API, we not only have access to custom properties and regular properties, but we can pass custom arguments to the <code>paint()</code> function as well.</p>

<p>We can add these extra arguments when we call the function in the CSS. Let's say we want to sometimes stroke our background instead of fill it — let's pass in an extra argument for this occasion.</p>

<pre class="brush: css">li {
	background-image: paint(hollowHighlights, stroke);
}
</pre>

<p>Now we can use the <code>inputArguments()</code> method in the <code>registerPaint()</code> class to access the custom argument we have added to our <code>paint()</code> function.</p>

<pre class="brush: js">static get inputArguments() { return ['*']; }
</pre>

<p>We then have access to that argument.</p>

<pre class="brush:js">paint(ctx, size, props, args) {

	// use our custom arguments
	const hasStroke = args[0].toString();

	// if stroke arg is 'stroke', don't fill
	if (hasStroke === 'stroke') {
		ctx.fillStyle = 'transparent';
		ctx.strokeStyle = colour;
	}
	...
}
</pre>

<p>We can pass more than one argument.</p>

<pre class="brush: css">li {
	background-image: paint(hollowHighlights, stroke, 10px);
}
</pre>

<p>We can also specify that we want a particular type of argument. When we <code>get</code> our list of argument values, we ask specifically for a <code>&lt;length&gt;</code> unit.</p>

<pre class="brush: js">static get inputArguments() { return ['*', '&lt;length&gt;']; }</pre>

<p>In this case, we specifically requested the <code>&lt;length&gt;</code> attribute. The first element in the returned array will be a <code><a href="/en-US/docs/Web/API/CSSUnparsedValue">CSSUnparsedValue</a></code>. The second will be a <code><a href="/en-US/docs/Web/API/CSSStyleValue">CSSStyleValue.</a></code></p>

<p>If the custom argument is a CSS value, for instance a unit, we can invoke Typed OM CSSStyleValue class (and sub classes) by using the value type keyword when we retrieve it in the <code>registerPaint()</code> function.</p>

<p>Let's say we add a second argument with how many pixels wide we want the stroke to be:</p>

<pre class="brush: css">li {
	background-image: paint(hollowHighlights, stroke, 10px);
}
</pre>

<p>When we <code>get</code> our list of argument values, we can ask specifically for a <code>&lt;length&gt;</code> unit.</p>

<pre class="brush: js">static get inputArguments() { return ['*', '&lt;length&gt;']; }
</pre>

<p>Now we can access the type and value properties, meaning we can get the number of pixels and a number type right out of the box. (Admittedly, <code>ctx.lineWidth</code> takes a float as a value rather than a value with length units, but for example's sake...)</p>

<pre class="brush: js">paint(ctx, size, props, args) {

		const strokeWidth = args[1];

		if (strokeWidth.unit === 'px') {
			ctx.lineWidth = strokeWidth.value;
		} else {
			ctx.lineWidth = 1.0;
		}

	...
}
</pre>

<p>It's worth noting the difference between using custom properties to control different parts of this worklet and the arguments set out here. Custom properties (and in fact any properties on the style map) are global — they can be used elsewhere within our CSS (and JS).</p>

<p>You may for example have a <code>--mainColor</code>, which will be useful for setting the color within a <code>paint()</code> function, but can also be used to set colors elsewhere in your CSS. If you wanted to change it specifically for paint, it could prove difficult. This is where the custom argument feature comes in handy. Another way to think about it is that arguments are set to control what you are actually drawing, whereas properties are set to control styling.</p>

<p><img alt="The list items have a background image that is either pink, purple or green, with different stroke widths, and the green one being filled." src="https://mdn.mozillademos.org/files/16786/hollowfilled.png" style="height: 292px; width: 327px;"></p>

<p>Now we can really start to see the benefits of this API, if we can control a myriad of drawing parameters from our CSS through both custom properties and extra <code>paint()</code> function arguments, then we can really start to build reusable and highly controllable styling functions.</p>

<pre class="brush: js">registerPaint('hollowHighlights', class {

  static get inputProperties() { return ['--boxColor']; }
  // Input arguments that can be passed to the `paint` function
  static get inputArguments() { return ['*','']; }

  static get contextOptions() { return {alpha: true}; }

  paint(ctx, size, props, args) {
    // ctx   -&gt; drawing context
    // size  -&gt; size of the box being painted
    // props -&gt; list of custom properties available to the element
	// args  -&gt; list of arguments set when calling the paint() function in the css

		// where to start the highlight &amp; dimensions
		const x = 0;
		const y = size.height * 0.3;
		const blockWidth = size.width * 0.33;
		const blockHeight = size.height * 0.85;

		// the values passed in the paint() function in the CSS
		const colour = props.get( '--boxColor' );
		const strokeType = args[0].toString();
		const strokeWidth = parseInt(args[1]);

		// set the stroke width
		if ( strokeWidth ) {
			ctx.lineWidth = strokeWidth;
		} else {
			ctx.lineWidth = 1.0;
		}
		// set the fill type
		if ( strokeType === 'stroke' ) {
			ctx.fillStyle = 'transparent';
			ctx.strokeStyle = colour;
		} else if ( strokeType === 'filled' ) {
			ctx.fillStyle = colour;
			ctx.strokeStyle = colour;
		} else {
			ctx.fillStyle = 'none';
			ctx.strokeStyle = 'none';
		}

		// block
		ctx.beginPath();
		ctx.moveTo( x, y );
		ctx.lineTo( blockWidth, y );
		ctx.lineTo( blockWidth + blockHeight, blockHeight );
		ctx.lineTo( x, blockHeight );
		ctx.lineTo( x, y );
		ctx.closePath();
		ctx.fill();
		ctx.stroke();
		// dashes
		for (let i = 0; i &lt; 4; i++) {
			let start = i * 2;
			ctx.beginPath();
			ctx.moveTo( blockWidth + (start * 10) + 10, y);
			ctx.lineTo( blockWidth + (start * 10) + 20, y);
			ctx.lineTo( blockWidth + (start * 10) + 20 + blockHeight, blockHeight);
			ctx.lineTo( blockWidth + (start * 10) + 10 + blockHeight, blockHeight);
			ctx.lineTo( blockWidth + (start * 10) + 10, y);
			ctx.closePath();
			ctx.fill();
			ctx.stroke();
		}

  } // paint
});
</pre>

<p>We can set different colors, stroke widths, and pick whether the background image should be filled or hollow:</p>

<div id="example5">
<pre class="brush: css">li {
   --boxColor: hsla(155, 90%, 60%, 0.5);
   background-image: paint(hollowHighlights, stroke, 5px);
}

li:nth-of-type(3n) {
   --boxColor: hsla(255, 90%, 60%, 0.5);
   background-image: paint(hollowHighlights, filled,  3px);
}

li:nth-of-type(3n+1) {
   --boxColor: hsla(355, 90%, 60%, 0.5);
   background-image: paint(hollowHighlights, stroke, 1px);
}</pre>

<pre class="brush: html; hidden">&lt;ul&gt;
    &lt;li&gt;item 1&lt;/li&gt;
    &lt;li&gt;item 2&lt;/li&gt;
    &lt;li&gt;item 3&lt;/li&gt;
    &lt;li&gt;item 4&lt;/li&gt;
    &lt;li&gt;item 5&lt;/li&gt;
    &lt;li&gt;item 6&lt;/li&gt;
    &lt;li&gt;item 7&lt;/li&gt;
    &lt;li&gt;item 8&lt;/li&gt;
    &lt;li&gt;item 9&lt;/li&gt;
    &lt;li&gt;item 10&lt;/li&gt;
    &lt;li&gt;item 11&lt;/li&gt;
    &lt;li&gt;item 12&lt;/li&gt;
    &lt;li&gt;item 13&lt;/li&gt;
    &lt;li&gt;item 14&lt;/li&gt;
    &lt;li&gt;item 15&lt;/li&gt;
    &lt;li&gt;item 16&lt;/li&gt;
    &lt;li&gt;item 17&lt;/li&gt;
    &lt;li&gt;item&lt;/li&gt;
&lt;/ul&gt;
</pre>

<p>In our <code>&lt;script&gt;</code> we register the worklet:</p>

<pre class="brush: js">CSS.paintWorklet.addModule('https://mdn.github.io/houdini-examples/cssPaint/intro/worklets/hollow.js');</pre>
</div>

<p>{{EmbedLiveSample("example5", 300, 300)}}</p>

<h2 id="See_Also">See Also</h2>

<ul>
 <li><a href="/en-US/docs/Web/API/CSS_Painting_API">CSS Painting API </a></li>
 <li><a href="/en-US/docs/Web/Houdini/CSS_Typed_OM">CSS Typed Object Model API</a></li>
</ul>
